#include "points.hpp"

#include "exception.hpp"

#include <QString>

Points stringToPoints(QString s) noexcept(false) {
    if (s.isEmpty() || s == "-") {
        return Points{0.};
    }

    // dynexite file might use dot or comma as decimal separator
    s.replace(',', '.');

    bool success;
    const auto res = s.toDouble(&success);
    if (success) {
        return Points{res};
    } else {
        throw DynamiteException{"Could not convert string \"" + s +
                                "\" to a number."};
    }
}
