#include "data/nodes/user_grade_config.hpp"

#include "data/graph.hpp"

#include "data/testable_objects.hpp"

#include <gtest/gtest.h>

TEST(UserGradeConfigTest, constructor) {
    const UserGradeConfig uc;

    EXPECT_EQ(uc.mRequirePassAllParts, defaults::requirePassAllParts);
    EXPECT_EQ(uc.mPassDueToBonus, defaults::passDueToBonus);
}

TEST(UserGradeConfigTest, inDag) {

    const auto &myExams = exams();

    for (const auto &[name, g] : myExams) {

        EXPECT_EQ(g.mUserGradeConfig.mRequirePassAllParts,
                  defaults::requirePassAllParts);
        EXPECT_EQ(g.mUserGradeConfig.mPassDueToBonus, defaults::passDueToBonus);
    }
}
